#include <bits/stdc++.h>

using namespace std;

#define int long long

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    string s;
    cin>>s;
    vector<pair<int,int> > vp;
    int arr[s.size()]={};
    int t=1,tstart=0;
    for(int i=1;i<s.size();i++)
    {
        if((s[i]=='b' && s[i-1]=='c') || (s[i]=='a' && s[i-1]=='c') || (s[i]=='a' && s[i-1]=='b'))
        {
            for(int j=tstart;j<i;j++)
            {
                arr[j]=t;
            }
            t++;
            tstart=i;
        }
        if(i==s.size()-1)
        {
            for(int j=tstart;j<i;j++)
            {
                arr[j]=t;
            }
            arr[s.size()-1]=t;
            continue;
        }


    }

    /*for(int i=0;i<s.size();i++)
        cout<<arr[i]<<" ";
    cout<<'\n';*/

    int n;
    cin>>n;
    for(int i=0;i<n;i++)
    {
        int x,y;
        cin>>x>>y;
        cout<<arr[--y]-arr[--x]+1<<'\n';
    }
}
